=== VolViewExternalLibraries/LesionSizingKit/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(LesionSizingKitGlobal)

ADD_SUBDIRECTORY(Sandbox)
