=== VolViewApplications/Kitware/VolView/CMakeLists.txt ===
##=========================================================================
## 
##   Copyright (c) Kitware, Inc.
##   All rights reserved.
##   See Copyright.txt or http://www.kitware.com/VolViewCopyright.htm for details.
## 
##      This software is distributed WITHOUT ANY WARRANTY; without even
##      the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##      PURPOSE.  See the above copyright notice for more information.
## 
##=========================================================================
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(VolView)

# --------------------------------------------------------------------------
# We need VolViewLibraries

FIND_PACKAGE(VolViewLibraries REQUIRED)
INCLUDE(${VolViewLibraries_USE_FILE})

# --------------------------------------------------------------------------
# Create the executable

SET(BUILD_VolView ON)
INCLUDE("${KWVolView_CMAKE_DIR}/KWVolViewCreateExecutableMacros.cmake")
KWVolView_CREATE_EXECUTABLE(
  APPLICATION_NAME    "VolView"
  EXECUTABLE_NAME     "VolView"
  MAJOR_VERSION       3
  MINOR_VERSION       4
  RELEASE_NAME        ""
  LICENSE_FILE        "${VolViewApplications_SOURCE_DIR}/License.txt"
  SUPPORT_TRIAL_MODE  1
  SUPPORT_TESTING     1
  SUPPORT_TESTING_GUI 1
  SUPPORT_PLUGINS     1
  APPLICATION_CLASS_NAME "vtkVolViewApplication"
  EXTRA_SOURCES       "vtkVolViewApplication.cxx"
  INSTALL_DEFAULT_DATA_SAMPLES 1
  DOCUMENTATION_FILE  "Documentation/VolView 3 User Manual.pdf"
)
