=== VolViewExternalLibraries/LesionSizingKit/Sandbox/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(LesionSizingKitSandbox)

FIND_PACKAGE(ITK REQUIRED)
INCLUDE(${ITK_USE_FILE})


OPTION(ITK_USE_MULTI_PHASE_FRAMEWORK "Enable multi-phase level sets" OFF)

OPTION(LSTK_SANDBOX_BUILD_REPORTS "Build Lesion Sizing Toolkit Sandbox with LaTeX reports." OFF)

OPTION(LSTK_SANDBOX_USE_VTK "Build visualization helper tools." OFF)

IF( LSTK_SANDBOX_BUILD_REPORTS AND NOT LSTK_SANDBOX_USE_VTK )
  MESSAGE(FATAL_ERROR "In order to build the Report you MUST activate the option LSTK_SANDBOX_USE_VTK")
ENDIF( LSTK_SANDBOX_BUILD_REPORTS AND NOT LSTK_SANDBOX_USE_VTK )


ENABLE_TESTING()
INCLUDE(CTest)

INCLUDE_DIRECTORIES(
  ${LesionSizingKitSandbox_SOURCE_DIR}/Source
  )

IF (ITK_USE_MULTI_PHASE_FRAMEWORK)
  ADD_SUBDIRECTORY(Source)
ENDIF( ITK_USE_MULTI_PHASE_FRAMEWORK )
ADD_SUBDIRECTORY(Utilities)
IF(BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)

INCLUDE(${LesionSizingKitSandbox_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

IF(LSTK_SANDBOX_BUILD_REPORTS)
  ADD_SUBDIRECTORY(Documents)
ENDIF(LSTK_SANDBOX_BUILD_REPORTS)
