=== VolViewExternalLibraries/LesionSizingKit/Toolkit/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT(LesionSizingToolkit)

FIND_PACKAGE(ITK REQUIRED)
INCLUDE(${ITK_USE_FILE})

SET(EXECUTABLE_OUTPUT_PATH ${LesionSizingToolkit_BINARY_DIR}/bin CACHE INTERNAL "Where to put the executables") 
SET(LIBRARY_OUTPUT_PATH ${LesionSizingToolkit_BINARY_DIR}/bin CACHE INTERNAL "Where to put the libraries") 

ENABLE_TESTING()
INCLUDE(CTest)

INCLUDE_DIRECTORIES(
  ${LesionSizingToolkit_SOURCE_DIR}/Source
  )

ADD_SUBDIRECTORY(Source)
IF(BUILD_TESTING)
  ADD_SUBDIRECTORY(Testing)
ENDIF(BUILD_TESTING)
ADD_SUBDIRECTORY(Examples)

INCLUDE(${LesionSizingToolkit_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)
