=== debian/changelog ===
volview (3.4-3ubuntu1) raring; urgency=low

  * Fixed FTBFS (hardcoded Tcl and Tk locations in a CMakeLists.txt).
  * Made swab(3) available to avoid causing FTBFS on amd64 due to
    implicit function declaration.

 -- Daniel T Chen <crimsun@ubuntu.com>  Fri, 12 Apr 2013 16:29:36 -0400

volview (3.4-3build1) quantal; urgency=low

  * Rebuild for libgdcm2.2

 -- Michael Terry <mterry@ubuntu.com>  Mon, 23 Jul 2012 17:58:02 -0400

volview (3.4-3) unstable; urgency=low

  * Need to remove quote from CFLAGS (MIPS compilation)
  * fix compilation issues introduced by -fPIC
  * Bump Std-Vers to 3.9.3, no changes needed
  * Use my @d.o alias.
  * Remove DMUA flag
  * Use hardening flags. Closes: #665637

 -- Mathieu Malaterre <malat@debian.org>  Fri, 30 Mar 2012 17:31:14 +0200

volview (3.4-2) unstable; urgency=low

  * Use any curl.h provider
  * Make sure to use vtkedge 0.2 and above
  * Fix mipsel compilation. Closes: #658273
  * Use hardening flags

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 01 Feb 2012 21:14:28 +0100

volview (3.4-1) unstable; urgency=low

  * Initial release (Closes: #640511)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Fri, 30 Dec 2011 09:41:46 +0100
