=== debian/control ===
Source: volview
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 8), cmake (>= 2.8.2),
 libinsighttoolkit3-dev (>= 3.20), libvtk5-dev (>= 5.8.0), libfftw3-dev,
 libgdcm2-dev (>= 2.0.18), libkwwidgets1-dev, tcl8.5-dev, tk8.5-dev,
 libavformat-dev, libvtkedge-dev (>= 0.2), libcurl4-gnutls-dev | libcurl4-dev, libtar-dev
Standards-Version: 3.9.3
Homepage: http://www.kitware.com/products/volview.html
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/volview/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/volview/trunk/

Package: volview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Advanced volume visualization tool
 VolView is an intuitive, interactive system for volume visualization that
 allows researchers to quickly explore and analyze complex 3D medical or
 scientific data on Windows, Mac and Linux computers. Users can easily load and
 interactively explore datasets using 2D and 3D display methods and tools. 3D
 tools include volume rendering, maximum intensity projections, and oblique
 reformatting. The ability to save an entire visualization session allows users
 to easily stop and start sessions. Advanced users can perform custom data
 processing using a simple plug-in API.
