=== debian/watch ===
version=3
http://www.kitware.com/products/vvdownload.html \
http://www.kitware.com/VolView/files/VolView-([\d\.]+)-Linux-x86_64.sh
